# Agora-Project

Create your workspace to communicate with your team : share files, calendars, publish on a newsfeed, make polls, manage tasks, send newsletters, etc. Omnispace is ideal to work easily on a common project.

See the [project page](https://www.agora-project.net/?curTrad=english) for documentation and a demonstration.


## License

Agora-Project is licensed under the [GPLv2](http://choosealicense.com/licenses/gpl-3.0) license for all open source applications.


## Bugs and feature requests

If you find a bug or need a new feature, please report it [here on Github](https://github.com/xech/agora-project/issues)

Guidelines for bug reports:

1. Use the GitHub issue search — check if the issue has already been reported.
2. Check if the issue has been fixed — try to reproduce it using the latest master or development branch in the repository.
3. Isolate the problem — create a reduced test case and a live example.

A good bug report shouldn't leave others needing to chase you up for more information.
Please try to be as detailed as possible in your report.


## Installation guide

1. Check that your web server has a PHP version 5.5 or later, if possible with the "Imagick" library (creation of thumbnails of images).
2. Download the latest version of Agora-Project, then unpack the archive on your computer.
3. Go to your webserver (if necessary via FTP) and add the "app", "docs" and "DATAS" folders on your webserver.
4. Then, Add the file "index.php" : as long as this file is not present, the app will not be accessible.
5. Give "read", "write" and "execute" access rights to new folders and files (chmod 770 -R).
6. With your web browser, go to the URL of your new application, fill in the installation form and then validate it: your space is ready for use !
7. If you can, modify the "php.ini" file of your web server and modify the "post_max_size" and "upload_max_filesize" parameters to increase the size of the uploaded files.


## Screenshots
<p align="center">

  <b>File manager</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/file.jpg"><br><br><br>
 
  <b>Shared calendars</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/calendar.jpg"><br><br><br>

  <b>News and Polls</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/dashboard.jpg"><br><br><br>

  <b>Polls</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/dashboardPoll.jpg"><br><br><br>

  <b>Forum</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/forum.jpg"><br><br><br>

  <b>Shared Tasks/Notes</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/task.jpg"><br><br><br>

  <b>Newsletters</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/mail.jpg"><br><br><br>

  <b>Contacts directory</b><br><br>
  <img src="https://www.agora-project.net/app/img/screenshots/contact.jpg">
</p>
